"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var getCpuUsage_1 = require("./monitor/cpu/getCpuUsage");
var getUptime_1 = require("./monitor/getUptime");
var getReadDisk_1 = require("./monitor/io/getReadDisk");
var getWriteDisk_1 = require("./monitor/io/getWriteDisk");
var getHeapTotal_1 = require("./monitor/memory/getHeapTotal");
var getHeapUsed_1 = require("./monitor/memory/getHeapUsed");
var getResidentSetSize_1 = require("./monitor/memory/getResidentSetSize");
function createMetricsAsync() {
    return __awaiter(this, void 0, void 0, function () {
        var metrics, monitors, cpuUsageMetric, readDisk, writeDisk, formattedMetrics;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    metrics = [];
                    monitors = [getHeapUsed_1.getHeapUsed, getHeapTotal_1.getHeapTotal, getResidentSetSize_1.getResidentSetSize, getUptime_1.getUptime];
                    monitors.map(function (monitor) { return monitor(); }).forEach(function (metric) { return metrics.push(metric); });
                    return [4 /*yield*/, getCpuUsage_1.getCpuUsage()];
                case 1:
                    cpuUsageMetric = _a.sent();
                    metrics.push(cpuUsageMetric);
                    if (!(process.platform === "linux")) return [3 /*break*/, 4];
                    return [4 /*yield*/, getReadDisk_1.getReadDisk()];
                case 2:
                    readDisk = _a.sent();
                    metrics.push(readDisk);
                    return [4 /*yield*/, getWriteDisk_1.getWriteDisk()];
                case 3:
                    writeDisk = _a.sent();
                    metrics.push(writeDisk);
                    _a.label = 4;
                case 4:
                    formattedMetrics = metrics.join("\n");
                    return [2 /*return*/, formattedMetrics + "\n"];
            }
        });
    });
}
exports.createMetricsAsync = createMetricsAsync;
